# Prerequisite steps for Mac OS X users (OS X 10.10 Yosemite)

 - Install [Homebrew](http://brew.sh). Other package managers and building from source might also work, but aren't supported as of now. If you figure out fixes for those other options, you're welcome to open pullrequests, as long as the Homebrew build doesn't break.
 - `brew update`
 - `brew tap caskroom/cask`
 - `brew tap caskroom/fonts`
 - `brew tap homebrew/versions`
 - `brew tap homebrew/python`
 - `brew update` (yes, again)
 - `brew cask install font-dejavu-sans`
 - `brew install python3 libepoxy freetype fontconfig harfbuzz cmake sdl2 sdl2_image opus libogg opusfile libpng`
 - `brew install numpy --with-python3`
 - `brew install pillow --with-python3`
 - `brew install jinja2 --with-python3`
 - `brew install qt5`
 - Choose and Install a compatible compiler:
  - For clang 3.5: `brew install llvm35`
  - For gcc 4.9: `brew install gcc49`
 - Permanently add `/usr/local/bin` to your `$PATH` environment variable
 - Permanently add `/usr/local/lib/pkgconfig` and `/usr/local/lib` to your `$PKG_CONFIG_PATH` environment variable
 - Then run `pip3.5 install pygments cython`

You will also need [nyan](https://github.com/SFTtech/nyan/blob/master/doc/building.md) and its dependencies.
